VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PopClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public Server$
Public Account$
Public Password$
Public MessageCount%
Public LastError$

Private Mails As New Collection
Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Private firstline%, request%, answer%, lines$

Private Sub Class_Initialize()
Set Socket = New CSocket
Socket.LineSeparator = vbCrLf
Server$ = ""
Account$ = ""
Password$ = ""
MessageCount% = 0
LastError$ = ""
End Sub

Private Sub Class_Terminate()
Disconnect
Set Socket = Nothing
End Sub

Public Function Connect%()

If Socket.State = sockConnected Then Disconnect

Connect% = False
MessageCount% = 0
firstline% = 0: answer% = 0: request% = 0: lines$ = "": LastError$ = ""

Socket.Connect Server$, 110
Do While Socket.State = sockConnecting: DoEvents: Loop
If Socket.State <> sockConnected Then Exit Function

'warte auf 1. Zeile
Do Until answer% <> 0: DoEvents: Loop
If answer% <> 1 Then Exit Function

If Not popcommand%("USER " + Account$, 0) Then Exit Function
If Not popcommand%("PASS " + Password$, 0) Then Exit Function

Connect% = True

End Function

Public Function GetMails%()

GetMails% = False
MessageCount = 0
Do While Mails.Count: Mails.Remove 1: Loop

If Not popcommand%("LIST", 1) Then Exit Function

GetMails% = True

End Function

Public Function MessageSubject$(n%)

nr% = getnr%(n%)
If popcommand%("TOP" + Str$(nr%) + " 0", 3) Then
   MessageSubject$ = lines$
Else
   MessageSubject$ = LastError$
End If

End Function

Public Function Message$(n%)

nr% = getnr%(n%)
If popcommand%("RETR" + Str$(nr%), 2) Then
   Message$ = lines$
Else
   Message$ = LastError$
End If

End Function

Public Function Delete%(n%)

nr% = getnr%(n%)
If popcommand%("DELE" + Str$(nr%), 0) Then
   Delete% = True
   Mails.Remove n%
   MessageCount% = MessageCount% - 1
Else
   Delete% = False
End If

End Function

Public Sub Disconnect()

If Socket.State = sockConnected Then
   popcommand "QUIT", 0
   Socket.Disconnect
End If

End Sub

Private Function popcommand%(cmd$, r%)
popcommand% = False
If Socket.State <> sockConnected Then LastError$ = "Not Connected.": Exit Function
firstline% = 0: answer% = 0: request% = r%: lines$ = "": LastError$ = ""
'Debug.Print "> "; cmd$
Socket.SendData cmd$
Do Until answer% <> 0: DoEvents: Loop
popcommand% = (answer% = 1)
End Function

Private Function parse$(a$, ch$)
ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If
End Function

Private Sub SOCKET_ERROR(Error As Long, Description As String)
LastError$ = Description
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)

'r%=0   'wait for "+|-..."
'   1   'wait for "+|-..." and count lines until "."
'   2   'collect lines
'   3   'collect subject in lines

If LineData = "." Then
   answer% = 1  'fertig & ok
Else
   If firstline% = 0 Then
      firstline% = 1
      'Debug.Print "< "; LineData
      If request% = 0 And Left$(LineData, 1) = "+" Then answer% = 1
      If Left$(LineData, 1) = "-" Then answer% = 2: LastError$ = Mid$(LineData, 2)
   ElseIf request% = 1 Then
      MessageCount = MessageCount + 1
      Mails.Add parse$(LineData, " ")
   ElseIf request% = 2 Then
      lines$ = lines$ + LineData + vbCrLf
   ElseIf request% = 3 Then
      If LCase$(Left$(LineData, 8)) = "subject:" And lines$ = "" Then lines$ = Trim$(Mid$(LineData, 9))
   End If
End If

End Sub

Function getnr%(n%)

If n% >= 1 And n% <= Mails.Count Then
   getnr% = Val(Mails(n%))
Else
   getnr% = 0
End If

End Function

